package com.zhongzheng.modules.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.pay.domain.PayAisle;
import com.zhongzheng.modules.pay.domain.PayNature;
import com.zhongzheng.modules.pay.domain.PayPayee;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.pay.bo.PayServeAddBo;
import com.zhongzheng.modules.pay.bo.PayServeQueryBo;
import com.zhongzheng.modules.pay.bo.PayServeEditBo;
import com.zhongzheng.modules.pay.domain.PayServe;
import com.zhongzheng.modules.pay.mapper.PayServeMapper;
import com.zhongzheng.modules.pay.vo.PayServeVo;
import com.zhongzheng.modules.pay.service.IPayServeService;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 服务模式Service业务层处理
 *
 * @author ruoyi
 * @date 2021-10-12
 */
@Service
public class PayServeServiceImpl extends ServiceImpl<PayServeMapper, PayServe> implements IPayServeService {

    @Override
    public PayServeVo queryById(Long serveId){
        PayServe db = this.baseMapper.selectById(serveId);
        return BeanUtil.toBean(db, PayServeVo.class);
    }

    @Override
    public List<PayServeVo> queryList(PayServeQueryBo bo) {
        LambdaQueryWrapper<PayServe> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getServeName()), PayServe::getServeName, bo.getServeName());
        lqw.in(bo.getStatus() != null, PayServe::getStatus, bo.getStatus());
        lqw.orderByDesc(PayServe::getUpdateTime);
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<PayServeVo> entity2Vo(Collection<PayServe> collection) {
        List<PayServeVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, PayServeVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<PayServe> page = (Page<PayServe>)collection;
            Page<PayServeVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(PayServeAddBo bo) {
        PayServe add = BeanUtil.toBean(bo, PayServe.class);
        LambdaQueryWrapper<PayServe> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getServeName()), PayServe::getServeName, bo.getServeName());
        List<Integer> status = new ArrayList<>();
        status.add(1);
        status.add(0);
        lqw.in(bo.getStatus() != null, PayServe::getStatus, status);
        List<PayServe> list = this.list(lqw);
        if (CollectionUtils.isNotEmpty(list)){
            throw new RuntimeException("重复服务模式名字");
        }
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(PayServeEditBo bo) {
        PayServe update = BeanUtil.toBean(bo, PayServe.class);
        LambdaQueryWrapper<PayServe> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getServeName()), PayServe::getServeName, bo.getServeName());
        lqw.like(bo.getServeId()!= null, PayServe::getServeId, bo.getServeId());
        List<PayServe> list = this.list(lqw);
        if (CollectionUtils.isEmpty(list)){
            lqw.clear();
            lqw.eq(StrUtil.isNotBlank(bo.getServeName()), PayServe::getServeName, bo.getServeName());
            List<Integer> status = new ArrayList<>();
            status.add(1);
            status.add(0);
            lqw.in(bo.getStatus() != null, PayServe::getStatus, status);
            List<PayServe> list1 = this.list(lqw);
            if (CollectionUtils.isNotEmpty(list1)){
                throw new IllegalArgumentException("重复服务模式名字");
            }
        }
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(PayServe entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
